#include "ray.h"

Ray::Ray(const Vector& o,const Vector& d, double lightspeed) : 
         origin_(o), direction_(d.normalized()), lightspeed_(lightspeed) {    
}

const Vector& Ray::getOrigin() const { 
    return origin_; 
}

void Ray::setOrigin(const Vector& v) { 
    origin_ = v; 
}

const Vector& Ray::getDirection() const { 
    return direction_; 
}

void Ray::setDirection(const Vector& n) {
    direction_ = n.normalized(); 
}

double Ray::getLightspeed() const { 
    return lightspeed_; 
}

void Ray::setLightspeed(double lightspeed) {
    lightspeed_ = lightspeed;
}
